Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.jasper.runtime
Class JspWriterImpl

    java.lang.Object
      java.io.Writer
          javax.servlet.jsp.JspWriter
              org.apache.jasper.runtime.JspWriterImpl

All Implemented Interfaces:
  Closeable, Flushable, Appendable

    public class JspWriterImpl

extends JspWriter

Write text to a character-output stream, buffering characters so as to provide for the efficient writing of single characters, arrays, and strings. Provide support for discarding for the output that has been buffered. This needs revisiting when the buffering problems in the JSP spec are fixed -akv What buffering problems? -kmc Add method for writing bytes. This allows static texts to be pre-encoded, for performance. Note that this can be done only if the page is unbuffered. -kmc

Author:
  Anil K. Vijendran, Kin-man Chung

Field Summary
`protected ByteWriter` | `byteOut`
`protected boolean` | `implementsByteWriter`

Fields inherited from class javax.servlet.jsp.JspWriter
`autoFlush, bufferSize, DEFAULT_BUFFER, NO_BUFFER, UNBOUNDED_BUFFER`

Fields inherited from class java.io.Writer
`lock`

Constructor Summary
`JspWriterImpl()`
`JspWriterImpl(ServletResponse response)` Create a buffered character-output stream that uses a default-sized output buffer.
`JspWriterImpl(ServletResponse response, int sz, boolean autoFlush)` Create a new buffered character-output stream that uses an output buffer of the given size.

Method Summary
`void` | `clear()` Discard the output buffer.
`void` | `clearBuffer()` Clears the current contents of the buffer.
`void` | `close()` Close the stream.
`void` | `flush()` Flush the stream.
`protected void` | `flushBuffer()` Flush the output buffer to the underlying character stream, without flushing the stream itself.
`int` | `getRemaining()` This method returns the number of unused bytes in the buffer.
`boolean` | `hasData()`
`void` | `newLine()` Write a line separator.
`void` | `print(boolean b)` Print a boolean value.
`void` | `print(char c)` Print a character.
`void` | `print(char[] s)` Print an array of characters.
`void` | `print(double d)` Print a double-precision floating-point number.
`void` | `print(float f)` Print a floating-point number.
`void` | `print(int i)` Print an integer.
`void` | `print(long l)` Print a long integer.
`void` | `print(Object obj)` Print an object.
`void` | `print(String s)` Print a string.
`void` | `println()` Terminate the current line by writing the line separator string.
`void` | `println(boolean x)` Print a boolean value and then terminate the line.
`void` | `println(char x)` Print a character and then terminate the line.
`void` | `println(char[] x)` Print an array of characters and then terminate the line.
`void` | `println(double x)` Print a double-precision floating-point number and then terminate the line.
`void` | `println(float x)` Print a floating-point number and then terminate the line.
`void` | `println(int x)` Print an integer and then terminate the line.
`void` | `println(long x)` Print a long integer and then terminate the line.
`void` | `println(Object x)` Print an Object and then terminate the line.
`void` | `println(String x)` Print a String and then terminate the line.
`void` | `write(boolean bytesOK, byte[] buf, String str)` Attempt to write a String pre-encoded with the page encoding.
`void` | `write(byte[] buf, int off, int len, int strlen)`
`void` | `write(char[] buf)` Write an array of characters.
`void` | `write(char[] cbuf, int off, int len)` Write a portion of an array of characters.
`void` | `write(int c)` Write a single character.
`void` | `write(String s)` Write a string.
`void` | `write(String s, int off, int len)` Write a portion of a String.

Methods inherited from class javax.servlet.jsp.JspWriter
`getBufferSize, isAutoFlush`

Methods inherited from class java.io.Writer
`append, append, append`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### implementsByteWriter

    protected boolean implementsByteWriter

### byteOut

    protected ByteWriter byteOut

Constructor Detail

### JspWriterImpl

    public JspWriterImpl()

### JspWriterImpl

    public JspWriterImpl(ServletResponse response)

  Create a buffered character-output stream that uses a default-sized output buffer.

  Parameters:
    `response` - A Servlet Response

### JspWriterImpl

    public JspWriterImpl(ServletResponse response,
                         int sz,
                         boolean autoFlush)

  Create a new buffered character-output stream that uses an output buffer of the given size.

  Parameters:
    `response` - A Servlet Response
    `sz` - Output-buffer size, a positive integer
  Throws:
    `IllegalArgumentException` - If sz is <= 0

Method Detail

### flushBuffer

    protected final void flushBuffer()
                              throws IOException

  Flush the output buffer to the underlying character stream, without flushing the stream itself. This method is non-private only so that it may be invoked by PrintStream.

  Throws:
    `IOException`

### clear

    public final void clear()
                     throws IOException

  Discard the output buffer.

  Specified by:
    `clear` in class `JspWriter`
  Throws:
    `IOException` - If an I/O error occurs

### clearBuffer

    public void clearBuffer()
                     throws IOException

  Description copied from class: `JspWriter`
  Clears the current contents of the buffer. Unlike clear(), this method will not throw an IOException if the buffer has already been flushed. It merely clears the current content of the buffer and returns.

  Specified by:
    `clearBuffer` in class `JspWriter`
  Throws:
    `IOException` - If an I/O error occurs

### flush

    public void flush()
               throws IOException

  Flush the stream.

  Specified by:
    `flush` in interface `Flushable`
  Specified by:
    `flush` in class `JspWriter`
  Throws:
    `IOException` - If an I/O error occurs

### close

    public void close()
               throws IOException

  Close the stream.

  Specified by:
    `close` in interface `Closeable`
  Specified by:
    `close` in class `JspWriter`
  Throws:
    `IOException` - If an I/O error occurs

### getRemaining

    public int getRemaining()

  Description copied from class: `JspWriter`
  This method returns the number of unused bytes in the buffer.

  Specified by:
    `getRemaining` in class `JspWriter`
  Returns:
    the number of bytes unused in the buffer

### write

    public void write(boolean bytesOK,
                      byte[] buf,
                      String str)
               throws IOException

  Attempt to write a String pre-encoded with the page encoding.

  Parameters:
    `bytesOK` - If true, write out the byte array, else, write out the String.
    `buf` - The text encoded with the page encoding
    `str` - The original text
  Throws:
    `IOException`

### write

    public void write(byte[] buf,
                      int off,
                      int len,
                      int strlen)
               throws IOException

  Throws:
    `IOException`

### write

    public void write(int c)
               throws IOException

  Write a single character.

  Overrides:
    `write` in class `Writer`
  Throws:
    `IOException`

### write

    public void write(char[] cbuf,
                      int off,
                      int len)
               throws IOException

  Write a portion of an array of characters.

  Ordinarily this method stores characters from the given array into this stream's buffer, flushing the buffer to the underlying stream as needed. If the requested length is at least as large as the buffer, however, then this method will flush the buffer and write the characters directly to the underlying stream. Thus redundant `DiscardableBufferedWriter`s will not copy data unnecessarily.

  Specified by:
    `write` in class `Writer`
  Parameters:
    `cbuf` - A character array
    `off` - Offset from which to start reading characters
    `len` - Number of characters to write
  Throws:
    `IOException`

### write

    public void write(char[] buf)
               throws IOException

  Write an array of characters. This method cannot be inherited from the Writer class because it must suppress I/O exceptions.

  Overrides:
    `write` in class `Writer`
  Throws:
    `IOException`

### write

    public void write(String s,
                      int off,
                      int len)
               throws IOException

  Write a portion of a String.

  Overrides:
    `write` in class `Writer`
  Parameters:
    `s` - String to be written
    `off` - Offset from which to start reading characters
    `len` - Number of characters to be written
  Throws:
    `IOException`

### write

    public void write(String s)
               throws IOException

  Write a string. This method cannot be inherited from the Writer class because it must suppress I/O exceptions.

  Overrides:
    `write` in class `Writer`
  Throws:
    `IOException`

### newLine

    public void newLine()
                 throws IOException

  Write a line separator. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline ('\n') character.

  Specified by:
    `newLine` in class `JspWriter`
  Throws:
    `IOException` - If an I/O error occurs

### print

    public void print(boolean b)
               throws IOException

  Print a boolean value. The string produced by ``String.valueOf(boolean)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `b` - The `boolean` to be printed
  Throws:
    `IOException` - If an error occured while writing

### print

    public void print(char c)
               throws IOException

  Print a character. The character is translated into one or more bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `c` - The `char` to be printed
  Throws:
    `IOException` - If an error occured while writing

### print

    public void print(int i)
               throws IOException

  Print an integer. The string produced by ``String.valueOf(int)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `i` - The `int` to be printed
  Throws:
    `IOException` - If an error occured while writing
  See Also:
    `Integer.toString(int)`

### print

    public void print(long l)
               throws IOException

  Print a long integer. The string produced by ``String.valueOf(long)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `l` - The `long` to be printed
  Throws:
    `IOException` - If an error occured while writing
  See Also:
    `Long.toString(long)`

### print

    public void print(float f)
               throws IOException

  Print a floating-point number. The string produced by ``String.valueOf(float)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `f` - The `float` to be printed
  Throws:
    `IOException` - If an error occured while writing
  See Also:
    `Float.toString(float)`

### print

    public void print(double d)
               throws IOException

  Print a double-precision floating-point number. The string produced by ``String.valueOf(double)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `d` - The `double` to be printed
  Throws:
    `IOException` - If an error occured while writing
  See Also:
    `Double.toString(double)`

### print

    public void print(char[] s)
               throws IOException

  Print an array of characters. The characters are converted into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `s` - The array of chars to be printed
  Throws:
    `NullPointerException` - If `s` is `null`
    `IOException` - If an error occured while writing

### print

    public void print(String s)
               throws IOException

  Print a string. If the argument is `null` then the string `"null"` is printed. Otherwise, the string's characters are converted into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `s` - The `String` to be printed
  Throws:
    `IOException` - If an error occured while writing

### print

    public void print(Object obj)
               throws IOException

  Print an object. The string produced by the ``String.valueOf(Object)`` method is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.

  Specified by:
    `print` in class `JspWriter`
  Parameters:
    `obj` - The `Object` to be printed
  Throws:
    `IOException` - If an error occured while writing
  See Also:
    `Object.toString()`

### println

    public void println()
                 throws IOException

  Terminate the current line by writing the line separator string. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline character (`'\n'`). Need to change this from PrintWriter because the default println() writes to the sink directly instead of through the write method...

  Specified by:
    `println` in class `JspWriter`
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(boolean x)
                 throws IOException

  Print a boolean value and then terminate the line. This method behaves as though it invokes ``print(boolean)`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the boolean to write
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(char x)
                 throws IOException

  Print a character and then terminate the line. This method behaves as though it invokes ``print(char)`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the char to write
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(int x)
                 throws IOException

  Print an integer and then terminate the line. This method behaves as though it invokes ``print(int)`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the int to write
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(long x)
                 throws IOException

  Print a long integer and then terminate the line. This method behaves as though it invokes ``print(long)`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the long to write
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(float x)
                 throws IOException

  Print a floating-point number and then terminate the line. This method behaves as though it invokes ``print(float)`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the float to write
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(double x)
                 throws IOException

  Print a double-precision floating-point number and then terminate the line. This method behaves as though it invokes ``print(double)`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the double to write
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(char[] x)
                 throws IOException

  Print an array of characters and then terminate the line. This method behaves as though it invokes ``print(char[])`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the char[] to write
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(String x)
                 throws IOException

  Print a String and then terminate the line. This method behaves as though it invokes ``print(String)`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the String to write
  Throws:
    `IOException` - If an error occured while writing

### println

    public void println(Object x)
                 throws IOException

  Print an Object and then terminate the line. This method behaves as though it invokes ``print(Object)`` and then ``println()``.

  Specified by:
    `println` in class `JspWriter`
  Parameters:
    `x` - the Object to write
  Throws:
    `IOException` - If an error occured while writing

### hasData

    public boolean hasData()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007 Mort Bay Consulting. All Rights Reserved.